/*jshint globalstrict:false, strict:false */
/*global assertEqual, assertTrue, assertNotEqual, JSON */
'use strict';

// //////////////////////////////////////////////////////////////////////////////
// / @brief Pregel Tests: graph generation
// /
// / @file
// /
// / DISCLAIMER
// /
// / Copyright 2022 ArangoDB GmbH, Cologne, Germany
// /
// / Licensed under the Apache License, Version 2.0 (the "License")
// / you may not use this file except in compliance with the License.
// / You may obtain a copy of the License at
// /
// /     http://www.apache.org/licenses/LICENSE-2.0
// /
// / Unless required by applicable law or agreed to in writing, software
// / distributed under the License is distributed on an "AS IS" BASIS,
// / WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// / See the License for the specific language governing permissions and
// / limitations under the License.
// /
// / Copyright holder is ArangoDB GmbH, Cologne, Germany
// /
// / @author Roman Rabinovich
// //////////////////////////////////////////////////////////////////////////////

const enterpriseGenerator = function (vColl, label) {
    return {
        makeEdge: function (from, to) {
            return {
                _from: `${vColl}/${label}:${from}`,
                _to: `${vColl}/${label}:${to}`,
                vertex: `${label}:${from}:${label}`
            };
        }, makeVertex: function (name) {
            return {
                _key: `${label}:${name}`,
                label: `${label}`
            };
        },
    };
};

const enterpriseMakeEdgeBetweenVertices = function(vColl, from, fromLabel, to, toLabel) {
    return {
        _from: `${vColl}/${fromLabel}:${from}`,
        _to: `${vColl}/${toLabel}:${to}`,
        vertex: `${fromLabel}:${from}:${toLabel}`
    };
};

exports.enterpriseGenerator = enterpriseGenerator;
exports.enterpriseMakeEdgeBetweenVertices = enterpriseMakeEdgeBetweenVertices;